using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

using MediaPortal.GUI.Library;
using MediaPortal.Hardware;
using MediaPortal.InputDevices;

namespace MessagePlugin
{
  public class MessagePlugin : ISetupForm, IPluginReceiver
  {
    const int WM_APP = 0x8000;
    const int ID_MESSAGE_COMMAND = 0x18;

    InputHandler inputHandler = new InputHandler("MessagePlugin");

    #region IPlugin Members

    void IPlugin.Start()  { }
    void IPlugin.Stop()   { }

    #endregion

    #region IPluginReceiver Members

    bool IPluginReceiver.WndProc(ref System.Windows.Forms.Message msg)
    {
      if (msg.Msg == WM_APP && msg.WParam.ToInt32() == ID_MESSAGE_COMMAND)
      {
        inputHandler.MapAction(msg.LParam.ToInt32() & 0xFFFF);
        return true;
      }

      return false;
    }

    #endregion

    #region ISetupForm Members

    string ISetupForm.Author()        { return "and-81"; }
    bool ISetupForm.CanEnable()       { return true; }
    bool ISetupForm.DefaultEnabled()  { return true; }
    string ISetupForm.Description()   { return "Send windows messages to MediaPortal and map them through the input handler."; }
    int ISetupForm.GetWindowId()      { return 0; }
    bool ISetupForm.HasSetup()        { return true; }
    string ISetupForm.PluginName()    { return "MessagePlugin"; }
    void ISetupForm.ShowPlugin()
    {
      InputMappingForm inputMappingForm = new InputMappingForm("MessagePlugin");
      inputMappingForm.ShowDialog();
    }

    bool ISetupForm.GetHome(out string strButtonText, out string strButtonImage, out string strButtonImageFocus, out string strPictureImage)
    {
      strButtonText = strButtonImage = strButtonImageFocus = strPictureImage = "";
      return false; 
    }

    #endregion

  }

}
